<?php
/*
Plugin Name: Jadwal Shalat
Plugin URI: https://garudatheme.com
Description: Merupakan plugin yang dibuat untuk Anda yang ingin menambahkan widget jadwal shalat waktu Indonesia (Harian).
Version: 1.0
Author: Garudatheme
*/

if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

define( 'JADWAL_SHALAT_VERSION', '1.0' );

function jadwal_shalat_action_links( $links ) {
    $links[] = '<a href="' . get_admin_url( null, 'options-general.php?page=jadwal-shalat' ) . '">' . __('Settings') . '</a>';
    return $links;
}

add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), 'jadwal_shalat_action_links' );

function register_jadwal_shalat_scripts() {
    $screen = get_current_screen();
    if ( $screen->id == 'settings_page_jadwal-shalat' ) {
        wp_enqueue_style( 'jadwal-shalat-select2-style', plugin_dir_url( __FILE__ ) . 'assets/css/select2.min.css', array(), JADWAL_SHALAT_VERSION, 'all' );
        wp_enqueue_style( 'jadwal-shalat-admin-style', plugin_dir_url( __FILE__ ) . 'assets/css/jadwal-shalat-admin.css', array(), JADWAL_SHALAT_VERSION, 'all' );
        wp_enqueue_script( 'jadwal-shalat-select2-script', plugin_dir_url( __FILE__ ) . 'assets/js/select2.min.js', array( 'jquery' ), JADWAL_SHALAT_VERSION, true );
        wp_enqueue_script( 'jadwal-shalat-admin-script', plugin_dir_url( __FILE__ ) . 'assets/js/jadwal-shalat.js', array( 'jquery' ), JADWAL_SHALAT_VERSION, true );
    }
}
add_action( 'admin_enqueue_scripts', 'register_jadwal_shalat_scripts' );

function jadwal_shalat_front_scripts() {
    wp_enqueue_style( 'jadwal-shalat-style', plugin_dir_url( __FILE__ ) . 'assets/css/jadwal-shalat.css', array(), JADWAL_SHALAT_VERSION, 'all' );
    wp_add_inline_style( 'jadwal-shalat-style', ':root{--jadwal-shalat-color:' . get_option( 'jadwal_shalat_color', '#2271b1' ) . ';}' );
}
add_action( 'wp_enqueue_scripts', 'jadwal_shalat_front_scripts' );

function update_option_on_front_page_load() {
    if ( ! is_admin() ) {
        $latest_update = get_option( 'jadwal_shalat_latest_update' );
        $jadwal_shalat_json = get_option( 'jadwal_shalat_json' );
        $datenow = date_i18n( 'Ymd' );
        if ( empty( $latest_update ) || empty( $jadwal_shalat_json ) || $latest_update < $datenow ) {
            update_option( 'jadwal_shalat_latest_update', $datenow );
            $response = wp_remote_get( 'https://api.myquran.com/v2/sholat/jadwal/' . get_option( 'jadwal_shalat_city', 1301 ) . '/' . date_i18n( 'Y' ) . '/' . date_i18n('m') . '/' . date_i18n('d')  );
            if ( is_array( $response ) ) {
                update_option( 'jadwal_shalat_json', $response['body'] );
            }
        }
    }
}
add_action( 'wp', 'update_option_on_front_page_load' );

require_once( plugin_dir_path( __FILE__ ) . 'kelas.php' );