<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

class Jadwal_Shalat {
    public function __construct() {
        add_action( 'admin_menu', array(&$this, 'register_jadwal_shalat' ) );
    }

    public function register_jadwal_shalat() {
        add_submenu_page( 
            'options-general.php', 'Jadwal Shalat', 'Jadwal Shalat', 'manage_options', 'jadwal-shalat', array(&$this, 'jadwal_shalat_callback')
        );
    }

    public function jadwal_shalat_callback() {
        require_once( plugin_dir_path( __FILE__ ) . 'city-list.php' );
		$citylist = json_decode( $city_list, 1 );
		$jadwal_shalat_city = esc_attr( get_option( 'jadwal_shalat_city', 1301 ) );
		$jadwal_shalat_color = esc_attr( get_option( 'jadwal_shalat_color', '#2271b1' ) );

        $jadwal_shalat_json = get_option( 'jadwal_shalat_json' );
        if ( ! empty( $jadwal_shalat_json ) ) {
            $jadwal_shalat_array = json_decode( $jadwal_shalat_json, 1 );
            if ( isset( $jadwal_shalat_array['data']['id'] ) && $jadwal_shalat_array['data']['id'] !== $jadwal_shalat_city ) {
                $response = wp_remote_get( 'https://api.myquran.com/v2/sholat/jadwal/' . $jadwal_shalat_city . '/' . date_i18n( 'Y' ) . '/' . date_i18n('m') . '/' . date_i18n('d')  );
                if ( is_array( $response ) ) {
                    update_option( 'jadwal_shalat_json', $response['body'] );
                    update_option( 'jadwal_shalat_latest_update', date_i18n( 'Ymd' ) );
                }
            }
        }

        echo '<div class="wrap">';
        echo '<h1>Jadwal Shalat</h1>';
        echo '<div class="jadwal-shalat-wrapper">';
        echo '<form class="jadwal-shalat-form" action="options.php" method="post">';
        wp_nonce_field('update-options');
        echo '<div class="form-group"><label for="jadwal-shalat-city">Pilih Kota</label>';
        echo '<select id="jadwal-shalat-city" class="jadwal-shalat-city" name="jadwal_shalat_city">';
        foreach( $citylist['data'] as $city ) {
        	echo '<option value="' . $city['id'] . '"' . ( ( $jadwal_shalat_city == $city['id'] ) ? ' selected="selected"' : '' ) . '>' . $city['lokasi'] . '</option>';
        }
        echo '</select></div>';
        echo '<div class="form-group">';
        echo '<label for="jadwal-shalat-color">Pilih Skema Warna</label><input type="color" name="jadwal_shalat_color" id="jadwal-shalat-color" value="' . ( ( ! empty( $jadwal_shalat_color ) ) ? $jadwal_shalat_color : '#41b332' ) . '">';
        echo '</div>';
        echo '<input type="hidden" name="action" value="update"/><input type="hidden" name="page_options" value="jadwal_shalat_city,jadwal_shalat_color"/>';
        submit_button( 'Simpan Pengaturan' );
        echo '</form>';
        echo '<div class="jadwal-shalat-about"><h3>Tentang</h3><p>Jadwal Shalat merupakan plugin yang dibuat untuk Anda yang ingin menambahkan widget jadwal shalat waktu Indonesia (Harian).</p><p>Shortcode: <span class="js-shortcode-code">[jadwal_shalat orientation="horizontal"]</span></p><h4>Kredit</h4><ul><li>Garudatheme - https://garudatheme.com</li><li>Bang Hasan - https://banghasan.com</li><li>My Quran - https://myquran.com</li></ul></div>';
        echo '</div>';
    }
}

new Jadwal_Shalat();

function jadwal_shalat_shortcode( $atts ) {
	$atts = shortcode_atts(
		array(
		    'orientation' => 'horizontal',
		),
		$atts,
		'jadwal_shalat'
	);

	$orientation = ( ( $atts['orientation'] == 'vertical' ) ? 'vertical' : 'horizontal' );

    $jadwal_shalat_json = get_option( 'jadwal_shalat_json' );

    if ( ! empty( $jadwal_shalat_json ) ) {
        $jsa = json_decode( $jadwal_shalat_json, 1 );
        $result = '<div class="widget-jadwal-shalat ' . $orientation . '"><div class="js-heading"><span class="heading-left">' . $jsa['data']['lokasi'] . '</span><span class="heading-right">' . $jsa['data']['jadwal']['tanggal'] . '</span></div><ul class="js-content"><li><span class="title">Subuh</span><span class="time">' . $jsa['data']['jadwal']['subuh'] . '</span></li><li><span class="title">Dzuhur</span><span class="time">' . $jsa['data']['jadwal']['dzuhur'] . '</span></li><li><span class="title">Ashar</span><span class="time">' . $jsa['data']['jadwal']['ashar'] . '</span></li><li><span class="title">Maghrib</span><span class="time">' . $jsa['data']['jadwal']['maghrib'] . '</span></li><li><span class="title">Isya</span><span class="time">' . $jsa['data']['jadwal']['isya'] . '</span></li></ul></div>';
    } else {
        $result = '';
    }
    return $result;
}

add_shortcode( 'jadwal_shalat', 'jadwal_shalat_shortcode' );